#!/opt/pmx6/bin/perl
use PureMessage::Manager::Request qw($REQUEST %in %text);
use PureMessage::Manager::Users qw(open_db commit_db  change_password $users_err_str);
use PureMessage::Manager::Lang;
use strict;
my $m = PureMessage::Manager::Modules->new();

my $module = $m->get_default();
my %vars;
my $r = $REQUEST->get_response(
                'PureMessage::Manager::Response',
                        'stderr_to_stdout' =>1,
                                
        );

$r->title("password_chnage_title");
$r->{no_sidebar} = 1;
open_db();
my $uid = $ENV{REMOTE_USER};
my $pass = $REQUEST->query('pass');
my $cpass = $REQUEST->query('cpass');
my $oldpass = $REQUEST->query('oldpass');
my $referrer = $ENV{HTTP_REFERER};
if($referrer =~ /session_login\.cgi/ ){
	$r->print_notification(text('change_password_info'));
}
if ($pass and $pass =~ /^\*+$/) {
        $r->raise_error("no_changes");
}
elsif ($pass) {
	if ( $pass ne $cpass ) {
		$r->raise_error("pass_no_match");
	}
	elsif ( $pass !~ /\w/ ) {
		$r->raise_error("bad_password");
	}
	elsif ($pass !~ /^\*+$/) {
		   if(! change_password($uid, $oldpass, $pass)){
                  $r->raise_error($users_err_str);
           }else{
                commit_db();
                $r->print_notification(text("pass_updated"));
           }
	}
}
elsif (($referrer =~ /change_password\.cgi/) && (!$oldpass || !$pass || !$cpass)) {
	$r->raise_error("empty_password");
}

my ( $fields, $data ) = form();
my $tb = $r->ToolBar( buttons => [[
	{type=>'image', icon=>'save', name=>'save',  text=>'Update'}, 
    {type=>'image', icon=>'cancel', href=>"/$module", text=>'Cancel'},
	  ]] );

$r->print("<br><br><center>");
$r->addForm(name => "change_password",
            data => $data,
            width => 400,
            fields => $fields,
            columns => 1,
            title => text("change_password_form_title"),
            toolbar => $tb,
            action => 'change_password.cgi',
           );

$r->send();
sub form {
    my $fields =  [ 
                    text('login'),
                    text('oldpass'),
                    text('npass'),
                    text('cpass'),
                  ];
    my %ui = (
                    text('login') => $uid,
                    text('oldpass')  => '<input class=stretch size=20 type=password value="*****" name="oldpass" autocomplete="off">',
                    text('npass')  => '<input class=stretch size=20 type=password value="*****" name="pass" autocomplete="off">',
                    text('cpass') => '<input class=stretch size=20 type=password value="*****" name="cpass" autocomplete="off">',
            );
    return ($fields, \%ui);
}


