#!/tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl
use PureMessage::Manager::Request qw($REQUEST %in %text);
use PureMessage::Manager::Users qw(open_db commit_db list_user_membership get_merged_user_acl change_password $users_err_str);
use PureMessage::Manager::Modules;
use PureMessage::Manager::Lang;
use strict;

my %vars;
my $r = $REQUEST->get_response(
        'PureMessage::Manager::Response',
        'stderr_to_stdout' =>1,
        
);

$r->title("account_title");
$r->{no_sidebar} = 1;

open_db();
my $uid = $ENV{REMOTE_USER};
my $oldpass = $REQUEST->query('oldpass');
my $pass = $REQUEST->query('pass');
my $cpass = $REQUEST->query('cpass');
if ($pass and $pass =~ /^\*+$/) {
    $r->raise_error("no_changes");
}
elsif ($pass) {
    if ( $pass ne $cpass ) {
        $r->raise_error("pass_no_match");
    }
    elsif ( $pass !~ /\w/ ) {
        $r->raise_error("bad_password");
    }
    elsif ($pass !~ /^\*+$/) {
        $r->raise_error($users_err_str)
            unless change_password($uid, $oldpass, $pass);
        commit_db();
        $r->print_notification(text("pass_updated"));
    }
}

my %groups = list_user_membership($uid);
my $my_groups = join(",", keys %groups);

my $m = PureMessage::Manager::Modules->new();
my %perms = $m->get_permissions();
my %has = get_merged_user_acl($uid);
my $perms;
if ( $has{'*'} ) {
    $perms .= "<b>".text('all_modules')."</b>";
}
else {
    foreach ( sort keys %has ) {
        $perms .= "$perms{$_}{description} ";
    }
}

my ( $fields, $data ) = form();
my $tb = $r->ToolBar( buttons => [[
                {type=>'image', icon=>'save', name=>'save', text=>'Update'}, 
                {type=>'image', icon=>'cancel', href=>'/', text=>'Cancel'},
                ]] );

$r->print("<br><br><center>");
$r->addForm(name => "my_account",
            data => $data,
            width => 400,
            fields => $fields,
            columns => 1,
            title => text("account_form_title"),
            toolbar => $tb,
            action => 'my_account.cgi',
           );

$r->send();

sub form {
    my $fields =  [ 
                    text('login'),
                    text('member'), 
                    text('perms'), 
                    text('oldpass'),
                    text('pass'),
                    text('cpass'),
                  ];
    my %ui = (
                    text('login') => $uid,
                    text('oldpass')  => '<input class=stretch size=20 type=password value="*****" name="oldpass" autocomplete="off">',
                    text('pass')  => '<input class=stretch size=20 type=password value="*****" name="pass" autocomplete="off">',
                    text('cpass') => '<input class=stretch size=20 type=password value="*****" name="cpass" autocomplete="off">',
                    text('member')=> $my_groups, 
                    text('perms') => $perms, 
            );
    return ($fields, \%ui);
}
